package bz.bronze.wat;

import javax.swing.*;

public class Game {
	static JFrame window = new JFrame();
	static JPanel container = new JPanel();
	static Renderer renderer = new Renderer();
	static Player player = new Player();
	static Collisions collisions = new Collisions();
	
	static String title = "io.agar";
	
	static int width = 800;
	static int height = 600;
	
	static int tickRate = 60;
	static int SKIPTICKS = 1000 / tickRate;
	
	static long SLEEPTIME = 0;
	static long NEXT = System.currentTimeMillis();
	
	static boolean isRunning;
	
	public void tick()
	{
		while (isRunning)
		{
			NEXT += SKIPTICKS;
			SLEEPTIME = NEXT - System.currentTimeMillis();
			
			if(SLEEPTIME >= 0) {
	            try {
	            	player.move();
	            	collisions.check();
					Thread.sleep(SLEEPTIME);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
	        }
	        else {
	            // Running behind!
	        	System.out.println("Running Behind!");
	        }
			
			renderer.repaint();
		}
	}
	
	public void init()
	{
		isRunning = true;
		
		window.addKeyListener(new Controls());
		
		window.add(renderer);
		
		window.setTitle(title);
		window.setSize(width, height);
		window.setLocationRelativeTo(null);
		window.setResizable(false);
		window.setVisible(true);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
}